#!/usr/local/bin/python2.1

from common import *
import math

def generate_geometry(view):
    map = ImageMap("brush.ppm")
    material = Diffuse(0.3, 0.5, 0.2)
    view.material_checkpoint(material)
    material.Kd = map
    n = 10
    for x in range(-n, n):
        for y in range(-n,n):
            for z in range(0,n):
                cube = Cube()
                s = math.fmod(x*x + y*y + z*z, 2)
                cube.l2w = matrix.Matrix()
                cube.l2w.set_scale(s, s, s)
                rx = (x + y) * (y + z) * 726
                ry = z * x + y*10 + z * 129
                rz = x * y * z + y * 39
                cube.l2w.rotate(rx, ry, rz)
                cube.l2w.translate(x*3 + math.fmod(z*321 + x*y,4)-2,
                                   y*3 + math.fmod(x*z+y*111,4)-2,
                                   z*3 + math.fmod(x*y*z + z*30,4)-2)
                cube.l2w.rotate(8,12,0)
                view.add_geometry(cube, material, 3)
#    view.set_dof(4, 0.1, 50, 5)
    
run(generate_geometry, "CubeGrid")

