#! /usr/bin/env python

from common import *

#
# Test the zbuffer renderer
#
print 'Testing the zbuffer rendering pipeline'
view = ZBufferView()
view.set_format("1.85")
view.scale_viewport(3)
view.add_light(Direct(C=(1,1,1)))
view.add_light(Direct(C=(1,1,1),  L=(0,0,-1)))
view.set_samples(2)
view.set_filter("gaussian", 2)

plane = Plane()
plane.l2w = matrix.Matrix()
plane.l2w.set_scale(1, 2, 1)
plane.l2w.translate(-2, 0, 0)
plane.l2w.rotate(-30, 0, 0)
material = Diffuse(0.7, 0.6, 0.3)
displacement = LocalDisplacement(0.5)
map = ImageMap("noise.ppm")
displacement.D = map
view.add_geometry(plane, material, 3, displacement)

cube = Cube()
cube.l2w = matrix.Matrix()
cube.l2w.set_translate(2, 1, 2)
cube.l2w.rotate(20, 10, 5)
map = ImageMap("brush.ppm")
material = Diffuse(0.9, 0.4, 0.7)
material.Kd = map
view.add_geometry(cube, material, 3)

view.render()
view.get_image().write("test_render.ppm")


#
# Test the image processor
#
print 'Testing the image processing engine'
background = ip.gradient((1.0, 1.0, 1.0, 1, 1), (1.0, 1.0, 1.0, 1, 1),
                         (0.7, 0.7, 0.7, 1, 1), (0.7, 0.7, 0.7, 1, 1))
foreground = ip.read("test_render.ppm")
foreground = foreground.alpha_from_lum()
comp = ip.matte(foreground, background).get_image()
comp.write("test_ip.ppm")


#
# Test font rendering
#
print 'Testing the FreeType font rendering library'
background = ip.gradient((1.0, 1.0, 1.0, 1, 1), (1.0, 1.0, 1.0, 1, 1),
                         (0.7, 0.7, 0.7, 1, 1), (0.7, 0.7, 0.7, 1, 1))
im = background.get_image()
ft = ip.Font("/usr/share/fonts/default/TrueType/helr____.ttf")
ft.set_size(24)
ft.draw_string(im, 20, 50, "PARC: FreeType text rendering", 0.3, 0.3, 0.3)
im.write("test_font.ppm")


#
# Test the viewer
#
