/*
 * $Header$
 *
 * $Log$
 *
 */

#ifndef _BEZ_H_
#define _BEZ_H_


typedef struct bez_curve {
    int n;              /* number of values at each point (x,y,z,d0,d1,...) */
    double *p[4];
    double tmin, tmax;
} BEZ_CURVE;


typedef struct bez_patch {
    int n;
    double *p[4][4];
    double smin, smax;
    double tmin, tmax;
} BEZ_PATCH;


void BEZ_CURVE_init(BEZ_CURVE *curve, int n, double tmin, double tmax,
    double *p0, double *p1, double *p2, double *p3);
void BEZ_CURVE_eval(BEZ_CURVE *curve, double t, double *p);
void BEZ_CURVE_subdivide(BEZ_CURVE *curve, double t, BEZ_CURVE *t0,
    BEZ_CURVE *t1);


void BEZ_PATCH_sample_uniformly(BEZ_PATCH *patch, int s_count, int t_count,
    double smin, double tmin, double smax, double tmax,
    double *p, double *dpds, double *dpdt);

void BEZ_PATCH_init(BEZ_PATCH *patch, int n, double smin, double tmin,
    double smax, double tmax, double *p);

void BEZ_PATCH_subdivide_s(BEZ_PATCH *patch, double s,
    BEZ_PATCH *s0, BEZ_PATCH *s1);
void BEZ_PATCH_subdivide_t(BEZ_PATCH *patch, double t,
    BEZ_PATCH *t0, BEZ_PATCH *t1);
void BEZ_PATCH_subdivide_s_and_t(BEZ_PATCH *patch, double s, double t,
    BEZ_PATCH *s0t0, BEZ_PATCH *s1t0, BEZ_PATCH *s0t1, BEZ_PATCH *s1t1);


#endif /* _BEZ_H_ */
