#include "geometry_internal.h"

void
geometry_initialize(GEOMETRY *geometry)
{
    geometry->subd = SUBD_create();
    geometry->particle = NULL;
    geometry->patch = NULL;
}

void
geometry_delete(GEOMETRY *geometry)
{
    if (geometry->subd != NULL) {
        SUBD_destroy(geometry->subd);
        geometry->subd = NULL;
    }
}

void
GEOMETRY_print(GEOMETRY *geometry, FILE *fd)
{
    fprintf(fd, "Geometry at %p\n", geometry);
    if (geometry->subd != NULL) {
        SUBD_print(geometry->subd, fd);
    }
}

void
GEOMETRY_split(GEOMETRY *geometry, int *n, GEOMETRY **child)
{
    return;
}

void
GEOMETRY_generate_grids(GEOMETRY *geometry, MATRIX *l2s, int vp[4],
    double area, GRID_CAPTURE capture, void *user_data)
{
    if (geometry->subd != NULL) {
        SUBD_generate_grids(geometry->subd, l2s, vp, area, capture, user_data);
    }
}
