/* Copyright (c) 2001, Daniel Wexler, All Rights Reserved */
/*
 * $Header: /usr/local/cvsroot/flarg/lib/image/image_error.c,v 1.4 2001/12/20 21:25:32 wex Exp $
 *
 * $Log: image_error.c,v $
 * Revision 1.4  2001/12/20 21:25:32  wex
 * Removed EXPORT in favor of .def file.
 *
 * Revision 1.3  2001/12/19 00:59:08  wex
 * Win32 support (EXPORT), added image_rgba.c and VC++ project files.
 *
 * Revision 1.2  2001/10/26 15:48:36  wex
 * First working version
 *
 * Revision 1.1  2001/07/18 04:58:51  wex
 * Added
 *
 *
 */
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <errno.h>

#include "image.h"

int IMAGE_errno = IMAGE_ERR_NONE;

char *
IMAGE_error_string(void)
{
	switch (IMAGE_errno) {
	case IMAGE_ERR_NONE:
		return "No error";
	case IMAGE_ERR_MEMORY:
		return "Out of memory";
	case IMAGE_ERR_NO_CHANNEL:
		return "Channel does not exist";
	case IMAGE_ERR_READ_FORMAT:
		return "Unknown read format";
	case IMAGE_ERR_WRITE_FORMAT:
		return "Unknown write format";
    case IMAGE_ERR_FILE_NOT_OPEN:
        return "File not open for reading";
    case IMAGE_ERR_LIBC:
        return strerror(errno);
    case IMAGE_ERR_PPM:
        return "Error reading ppm format header";
	}

	return "Unknown error";
}
