/* Copyright (c) 2001, Daniel Wexler, All Rights Reserved */
/*
 * $Header: /usr/local/cvsroot/flarg/lib/image/image_format.h,v 1.2 2001/10/29 00:50:24 wex Exp $
 *
 * $Log: image_format.h,v $
 * Revision 1.2  2001/10/29 00:50:24  wex
 * Fixed -Wall warnings.
 *
 * Revision 1.1  2001/10/26 15:48:36  wex
 * First working version
 *
 *
 *
 */

#ifndef _IMAGE_FORMAT_H_
#define _IMAGE_FORMAT_H_

#include "image.h"


typedef struct image_format IMAGE_FORMAT;

typedef struct image_format_open_info {
    char *filename;
    IMAGE *image;
} IMAGE_FORMAT_OPEN_INFO;

typedef struct image_format_read_tile_info {
    IMAGE *image;
    int viewport[4];
} IMAGE_FORMAT_READ_TILE_INFO;

typedef struct image_format_write_info {
    char *filename;
    IMAGE *image;
} IMAGE_FORMAT_WRITE_INFO;

IMAGE_FORMAT *image_format_create(char *name);
void image_format_set_open_callback(IMAGE_FORMAT *format,
    int (*callback)(IMAGE_FORMAT_OPEN_INFO *));
void image_format_set_read_tile_callback(IMAGE_FORMAT *format,
    int (*callback)(IMAGE_FORMAT_READ_TILE_INFO *));
void image_format_set_write_callback(IMAGE_FORMAT *format,
    int (*callback)(IMAGE_FORMAT_WRITE_INFO *));
void image_format_add_extension(IMAGE_FORMAT *format, char *extension);
int image_format_open_for_tiled_reading(IMAGE *image, char *filename);
int image_format_read_tile(IMAGE *image, int viewport[4]);
int image_format_write(IMAGE *image, char *filename);


#endif /* _IMAGE_FORMAT_H_ */
