#include "ip_op.h"

typedef struct ip_fill_data {
    double color[5]; /* r,g,b,a,z */
} IP_FILL_DATA;

static int ip_fill_compute(IP_COMPUTE_INFO *info);


IP_OP *
IP_OP_fill(double r, double g, double b, double a, double z)
{
    IP_FILL_DATA *data;

    data = (IP_FILL_DATA *)malloc(sizeof(IP_FILL_DATA));
    if (data == NULL) {
        IP_errno = IP_ERR_MEMORY;
        return NULL;
    }

    data->color[0] = r;
    data->color[1] = g;
    data->color[2] = b;
    data->color[3] = a;
    data->color[4] = z;
    
    return ip_op_create("fill", ip_fill_compute, NULL, data);
}

static int
ip_fill_compute(IP_COMPUTE_INFO *info)
{
    IP_FILL_DATA *data = info->user_data;

    info->output[0] = data->color[0];
    info->output[1] = data->color[1];
    info->output[2] = data->color[2];
    info->output[3] = data->color[3];
    info->output[4] = data->color[4];

    return 0;
}

