#include "ip_op.h"

static int ip_matte_compute(IP_COMPUTE_INFO *info);


IP_OP *
IP_OP_matte(IP_OP *over, IP_OP *under)
{
    IP_OP *op;

    op = ip_op_create("matte", ip_matte_compute, NULL, NULL);
    ip_op_add_input(op, "over", over);
    ip_op_add_input(op, "under", under);
    
    return op;
}

static int
ip_matte_compute(IP_COMPUTE_INFO *info)
{
    double af, ab;

    af = info->input[0][3];
    ab = info->input[1][3];

    info->output[0] = /*af*/ info->input[0][0] + (1-af)*ab * info->input[1][0];
    info->output[1] = /*af*/ info->input[0][1] + (1-af)*ab * info->input[1][1];
    info->output[2] = /*af*/ info->input[0][2] + (1-af)*ab * info->input[1][2];

    /* multiply transparency and convert back to opacity */
    info->output[3] = 1 - (1 - af) * (1 - ab);

    /* choose closer z? */

    return 0;
}
