/* Copyright (c) 2001, Daniel Wexler, All Rights Reserved */
/*
 * $Header: /usr/local/cvsroot/flarg/lib/matrix/matrix.c,v 1.6 2001/11/13 07:53:01 wex Exp $
 *
 * $Log: matrix.c,v $
 * Revision 1.6  2001/11/13 07:53:01  wex
 * MATRIX objects are always python objects now.
 *
 * Revision 1.5  2001/10/29 00:50:27  wex
 * Fixed -Wall warnings.
 *
 * Revision 1.4  2001/10/26 15:48:40  wex
 * First working version
 *
 * Revision 1.3  2001/07/18 04:58:04  wex
 * First round of bugs cleared, basically working.
 *
 * Revision 1.2  2001/07/17 09:37:26  wex
 * Added glue
 *
 * Revision 1.1  2001/07/17 03:32:39  wex
 * Added
 *
 *
 */

#include <stdlib.h>

#include "matrix_internal.h"

void matrix_initialize(MATRIX *m);

#if 0
static void matrix_set_parent(MATRIX *m, MATRIX *parent);
static void matrix_remove_from_child_list(MATRIX *m, MATRIX *child);
#endif


MATRIX *
MATRIX_create(void)
{
    return matrix_alloc();
}

void
matrix_initialize(MATRIX *m)
{
#if 0    
    m->parent = NULL;
    m->child_count = 0;
    m->child = NULL;
#endif
    
    MATRIX_set_identity(m);
}

void
matrix_delete(MATRIX *m)
{
#if 0    
    int i;

    for (i = 0; i < m->child_count; i++) {
        matrix_set_parent(m->child[i], m->parent);
    }

    free(m->child);
    m->child = NULL;
    
    if (m->parent != NULL) {
        matrix_remove_from_child_list(m->parent, m);
        m->parent = NULL;
    }
#endif
}

void
MATRIX_destroy(MATRIX *m)
{
    Py_DECREF(m);
}

#if 0
static void
matrix_set_parent(MATRIX *m, MATRIX *parent)
{
    int i;
    MATRIX **old_child;
    
    m->parent = parent;
    old_child = parent->child;
    ++parent->child_count;
    
    parent->child = (MATRIX **)malloc(parent->child_count * sizeof(MATRIX *));
    if (parent->child == NULL) {
        MATRIX_errno = MATRIX_ERR_MEMORY;
        parent->child = old_child;
        return;
    }

    for (i = 0; i < parent->child_count - 1; i++) {
        parent->child[i] = old_child[i];
    }
    parent->child[parent->child_count - 1] = m;
}

static void
matrix_remove_from_child_list(MATRIX *m, MATRIX *child)
{
    int i;

    for (i = 0; i < m->child_count; i++) {
        if (m->child[i] == child) break;
    }

    if (i < m->child_count) {
        for (/*EMPTY*/; i < m->child_count - 1; i++) {
            m->child[i] = m->child[i+1];
        }
        --m->child_count;
    }
}

#endif

void
MATRIX_copy(MATRIX *src, MATRIX *dst)
{
    memcpy(dst->m, src->m, 16*sizeof(double));
#if 0    
    matrix_set_parent(dst, src->parent);
#endif    
}

void
MATRIX_transpose(MATRIX *src, MATRIX *dst)
{
    int i, j;
    for (i = 0; i < 4; i++) {
        for (j = 0; j < 4; j++) {
            dst->m[j][i] = src->m[i][j];
        }
    }
}

int
MATRIX_print(MATRIX *self, FILE *fp)
{
    int i, j;

    for (i = 0; i < 4; i++) {
        fprintf(fp, "[ ");
        for (j = 0; j < 4; j++) {
            fprintf(fp, "%5.5g ", self->m[i][j]);
        }
        fprintf(fp, "]\n");
    }
    
    return 0;
}

