/*
 * $Header: /usr/local/cvsroot/flarg/lib/matrix/matrix_internal.h,v 1.3 2001/11/13 07:53:01 wex Exp $
 *
 * $Log: matrix_internal.h,v $
 * Revision 1.3  2001/11/13 07:53:01  wex
 * MATRIX objects are always python objects now.
 *
 * Revision 1.2  2001/11/01 04:26:56  wex
 * Working with Python scene description and geometry shaders
 *
 * Revision 1.1  2001/07/17 09:37:26  wex
 * Added glue
 *
 *
 */

#ifndef _MATRIX_INTERNAL_H_
#define _MATRIX_INTERNAL_H_

#include "matrix.h"

#define MATRIX_EPSILON 0.00001

#define MATRIX_COPY_DATA(dst, src) (memcpy(dst, src, 16*sizeof(double)))


struct matrix {
    PyObject_HEAD
    
    double m[4][4];
    
    /* embedded hierarchy */
    MATRIX *parent;
    int child_count;
    MATRIX **child;
};


/* avoid freeing or allocating inital MATRIX for C & Python */
MATRIX *matrix_alloc(void);
void matrix_initialize(MATRIX *m);
void matrix_delete(MATRIX *m);


#endif /* _MATRIX_INTERNAL_H_ */
