/* Copyright (c) 2001, Daniel Wexler, All Rights Reserved */
/*
 * $Header: /usr/local/cvsroot/flarg/lib/pool/pool.h,v 1.1 2001/12/21 07:12:11 wex Exp $
 *
 * $Log: pool.h,v $
 * Revision 1.1  2001/12/21 07:12:11  wex
 * Initial working version.
 *
 *
 */

#ifndef _POOL_H_
#define _POOL_H_

#define POOL_ERR_NONE             0
#define POOL_ERR_MEMORY           1

/* contains the error code if a function returns an error */
extern int POOL_errno;

/* returns a user readable string for error messages */
char *POOL_error_string(void);

typedef struct pool POOL;


POOL *POOL_create(int item_size, int items_per_block);
void POOL_destroy(POOL *pool);

void *POOL_create_item(POOL *pool);
void POOL_destroy_item(POOL *pool, void *item);


#endif  /* _POOL_H_ */
