/* Copyright (c) 2000, Daniel Wexler, All Rights Reserved */
/*
 * $Header: /usr/local/cvsroot/flarg/lib/tui/tui_error.c,v 1.5 2002/01/03 06:50:13 wex Exp $
 *
 * $Log: tui_error.c,v $
 * Revision 1.5  2002/01/03 06:50:13  wex
 * Removed EXPORT, updated WIN32, handle some thread memory bugs.
 *
 * Revision 1.4  2001/12/19 01:01:44  wex
 * Support for Win32 including OpenGL and compiled as DLL.
 *
 * Revision 1.3  2000/09/30 15:59:14  wex
 * Saving and loading generated header files.
 *
 * Revision 1.2  2000/09/28 16:06:27  wex
 * Added TUI_APPLICATION, beginning layout and code output.
 *
 * Revision 1.1.1.1  2000/09/16 23:38:08  wex
 * Initial revision
 *
 */


#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <errno.h>

#include "tui.h"


int TUI_errno;


char *
TUI_error_string(void)
{
	switch (TUI_errno) {
	case 0:
		return "No error";
	case TUI_ERR_MEMORY:
		return "Out of memory";
	case TUI_ERR_DISPLAY:
		return "Cannot open X display";
	case TUI_ERR_WINDOW:
		return "Cannot create window";
	case TUI_ERR_EVENT:
		return "Unknown event code";
	case TUI_ERR_NO_WINDOW:
		return "Cannot find widget window";
	case TUI_ERR_VISUAL:
		return "Cannot create X visual";
	case TUI_ERR_FILENAME:
		return "Invalid layout filename";
	case TUI_ERR_OPEN:
		return "Cannot open layout file";
	case TUI_ERR_VERSION:
		return "Version incompatibility";
	}

	return "Unknown error";
}

