/* Copyright (c) 2001, Daniel Wexler, All Rights Reserved */
/*
 * $Header: /usr/local/cvsroot/flarg/lib/tui/tui_imv.h,v 1.2 2002/01/07 22:31:59 wex Exp $
 *
 * $Log: tui_imv.h,v $
 * Revision 1.2  2002/01/07 22:31:59  wex
 * Many fixes for both Windows and Linux, looped playback working
 *
 * Revision 1.1  2001/12/05 10:47:01  wex
 * Changes to support image viewer in Python, compilation without warnings
 *
 *
 */

#ifndef _TUI_IMV_INCLUDED_
#define _TUI_IMV_INCLUDED_

#include "tui.h"

typedef struct tui_imv_image {
    int x0, y0, x1, y1;         /* viewport */
    unsigned long *image;       /* RGBA packed GL format */
} TUI_IMV_IMAGE;

struct tui_imv {
    TUI_WIDGET *oglwindow;      /* display window */
    TUI_IMV_IMAGE **image;
    int min_frame;
    int max_frame;
    int cur_frame;
    int step;
    TUI_IMV_IMAGE *previous;

    double last_seconds;
    double rate;

    TUI_IMV_LOOPING looping;
};


#endif /* _TUI_IMV_INCLUDED_ */
