/* Copyright (c) 2001, Daniel Wexler, All Rights Reserved */
/*
 * $Header: /usr/local/cvsroot/flarg/lib/zb/zb_geometry.h,v 1.3 2001/12/05 10:40:44 wex Exp $
 *
 * $Log: zb_geometry.h,v $
 * Revision 1.3  2001/12/05 10:40:44  wex
 * Displacement, transparency, viewport scaling
 *
 * Revision 1.2  2001/11/13 11:46:27  wex
 * Removed ZB_GRID_DATA, ZB_GEOMETRY_DATA, and tile grid and geometry lists
 *
 * Revision 1.1  2001/10/26 15:48:42  wex
 * First working version
 *
 *
 */

#ifndef _ZB_GEOMETRY_H_
#define _ZB_GEOMETRY_H_

#include "zb_internal.h"

void zb_geometry_create_grids(ZB_GEOMETRY *geometry, void *data);
void zb_geometry_destroy(ZB_GEOMETRY *geometry);
ZB_GEOMETRY *zb_geometry_append(ZB_GEOMETRY *geometry, LIST **list);
ZB_LOCATION zb_geometry_compare_viewports(ZB_GEOMETRY *geometry,
    int viewport[4]);
int zb_geometry_viewport_contained(ZB_GEOMETRY *geometry, int viewport[4]);
int zb_geometry_below_viewport_top(ZB_GEOMETRY *geometry, int top);
int zb_geometry_compare(ZB_GEOMETRY *a, ZB_GEOMETRY *b, void *data);
ZB *zb_geometry_get_zb(ZB_GEOMETRY *geometry);
SHADER_MATERIAL *zb_geometry_get_material(ZB_GEOMETRY *geometry);
SHADER_MATERIAL *zb_geometry_get_displacement(ZB_GEOMETRY *geometry);
MATRIX *zb_geometry_get_l2w(ZB_GEOMETRY *);
MATRIX *zb_geometry_get_l2w_motion(ZB_GEOMETRY *);



#endif /* _ZB_GEOMETRY_H_ */

