/* Copyright (c) 2001, Daniel Wexler, All Rights Reserved */
/*
 * $Header: /usr/local/cvsroot/flarg/lib/zb/zb_grid.h,v 1.3 2001/11/13 11:46:27 wex Exp $
 *
 * $Log: zb_grid.h,v $
 * Revision 1.3  2001/11/13 11:46:27  wex
 * Removed ZB_GRID_DATA, ZB_GEOMETRY_DATA, and tile grid and geometry lists
 *
 * Revision 1.2  2001/11/12 09:14:12  wex
 * depth of field, shading rate, bug fixes and optimizations
 *
 * Revision 1.1  2001/10/26 15:48:42  wex
 * First working version
 *
 *
 */

#ifndef _ZB_GRID_H_
#define _ZB_GRID_H_

#include "zb_internal.h"

ZB_GRID *zb_grid_create(ZB *zb, GRID *ggrid, ZB_GEOMETRY *geometry);
void zb_grid_destroy(ZB_GRID *data);

int zb_grid_capture(GRID_INFO *info);
void zb_grid_render(ZB_GRID *grid, ZB_TILE *tile, int tile_viewport[4]);
ZB_LOCATION zb_grid_compare_viewports(ZB_GRID *grid, int viewport[4]);
int zb_grid_viewport_contained(ZB_GRID *grid, int viewport[4]);
int zb_grid_below_viewport_top(ZB_GRID *grid, int top);

    

#endif /* _ZB_GRID_H_ */
