/* Copyright (c) 2001, Daniel Wexler, All Rights Reserved */
/*
 * $Header: /usr/local/cvsroot/flarg/lib/zb/zb_pixel.h,v 1.3 2001/11/12 09:14:12 wex Exp $
 *
 * $Log: zb_pixel.h,v $
 * Revision 1.3  2001/11/12 09:14:12  wex
 * depth of field, shading rate, bug fixes and optimizations
 *
 * Revision 1.2  2001/11/10 06:00:39  wex
 * Support for camera window, supersampling and filtering.
 *
 * Revision 1.1  2001/10/26 15:48:42  wex
 * First working version
 *
 *
 */

#ifndef _ZB_PIXEL_H_
#define _ZB_PIXEL_H_

#include "zb_internal.h"


ZB_PIXEL *zb_pixel_create_array(int count, int viewport[4]);
void zb_pixel_destroy_array(ZB_PIXEL *pixel, int count);
void zb_pixel_filter_array(ZB_PIXEL *pixel, int count, IMAGE *output,
    ZB_FILTER *filter);
void zb_pixel_insert_surface(ZB_PIXEL *pixel, double color[4], double depth);
double zb_pixel_get_time(ZB_PIXEL *pixel);
void zb_pixel_get_offset_position(ZB_PIXEL *pixel, double *x, double *y);
void zb_pixel_get_lens_offset(ZB_PIXEL *pixel, double *u, double *v);
ZB_PIXEL *zb_pixel_array_get(ZB_PIXEL *pixel, int i);

ZB_FILTER *zb_filter_create(ZB_FILTER_TYPE type, int r, int ss);
void zb_filter_set_supersample_rate(ZB_FILTER *filter, int ss);
void zb_filter_set_radius(ZB_FILTER *filter, int r);


#endif /* _ZB_PIXEL_H_ */
