/* Copyright (c) 2001, Daniel Wexler, All Rights Reserved */
/*
 * $Header: /usr/local/cvsroot/flarg/lib/zb/zb_tile.h,v 1.3 2001/11/13 11:46:27 wex Exp $
 *
 * $Log: zb_tile.h,v $
 * Revision 1.3  2001/11/13 11:46:27  wex
 * Removed ZB_GRID_DATA, ZB_GEOMETRY_DATA, and tile grid and geometry lists
 *
 * Revision 1.2  2001/10/29 00:50:29  wex
 * Fixed -Wall warnings.
 *
 * Revision 1.1  2001/10/26 15:48:42  wex
 * First working version
 *
 *
 */

#ifndef _ZB_TILE_H_
#define _ZB_TILE_H_

#include "zb_internal.h"

int zb_tile_initialize(ZB *zb);
int zb_tile_render(ZB_TILE *zb);
void zb_tile_destroy(ZB_TILE *zb);
int zb_tile_get_pixel_count(ZB_TILE *tile);
ZB_PIXEL *zb_tile_get_pixel(ZB_TILE *tile, int i);
int zb_tile_create_pixels(ZB_TILE *tile);
LIST *zb_tile_get_grid_list(ZB_TILE *tile);
int zb_tile_hit_bbox(ZB_TILE *tile, int viewport[4]);
ZB *zb_tile_get_zb(ZB_TILE *tile);
int zb_tile_contains_geometry(ZB_TILE *tile, ZB_GEOMETRY *geometry);

#endif /* _ZB_TILE_H_ */
